
;
;    Xameleon fasm demo (c) alman @ Xameleon project
;

    format	ELF

    section '.text' executable writable
    public start as '_start'
    public rootserver_id
    extrn main    

struc L4_KIP
{
    .Prefix		dd	??	; 0x00
    .API_Version	dd	??	; 0x04
    .API_Flags		dd	??	; 0x08
    .KernDescPtr	dd	??	; 0x0c
    
			dq	??	; 0x10 reserved
			dq	??	; 0x18 reserved
			dq	??	; 0x20 reserved
			dq	??	; 0x28 reserved
			dq	??	; 0x30 reserved
			dq	??	; 0x38 reserved
			dq	??	; 0x40 reserved
			dq	??	; 0x48 reserved
			
			dd	??	; 0x50 reserved
    .MemoryInfo		dd	??	; 0x54 reserved
			dq	??	; 0x58 reserved

			dq	??	; 0x60 reserved
			dq	??	; 0x68 reserved
			dq	??	; 0x70 reserved
			dq	??	; 0x78 reserved
			dq	??	; 0x80 reserved
			dq	??	; 0x88 reserved
			dq	??	; 0x90 reserved
			dq	??	; 0x98 reserved

			dq	??	; 0xa0 reserved
    .UtcbInfo		dd	??	; 0xa8
    .KipAreaInfo	dd	??	; 0xac
    
			dq	??	; 0xb0 reserved
    .BootInfo		dd	??	; 0xb8
    .ProcDescPtr	dd	??	; 0xbc

    .ClockInfo		dd	??	; 0xc0
    .ThreadInfo		dd	??	; 0xc4
    .PageInfo		dd	??	; 0xc8
    .ProcessorInfo	dd	??	; 0xcc
    
; -----	L4 system calls ----
    .SpaceControl	dd	??	; 0xd0
    .ThreadControl	dd	??	; 0xd4
    .ProcessControl	dd	??	; 0xd8
    .MemoryControl	dd	??	; 0xdc
    
    .IPC		dd	??	; 0xe0
    .LIPC		dd	??	; 0xe4
    .Unmap		dd	??	; 0xe8
    .ExchangeRegisters	dd	??	; 0xec
    
    .SystemClock	dd	??	; 0xf0
    .ThreadSwitch	dd	??	; 0xf4
    .Schedule		dd	??	; 0xf8
			dd	??	; 0xfc - Reserved syscall
}

macro ccall proc,[arg]
{ common
    local size
    size = 0
   reverse
    pushd arg
    size = size+4
   common
    call proc
    add esp,size 
}

macro L4_KDB_Enter msg
{
    local jump
    int3
    jmp		jump
    
    mov		eax, msg 
jump: 
}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:                          ; start of execution

;    mov  [env_size], esp
;    add  [env_size], 16 
	
    push	ebp
    mov		ebp, esp

    lock nop			; Get KIP pointer into EAX
    mov	 [kip], eax

;    L4_KDB_Enter hello_string

    mov   ax, [ eax + 198 ]
    shr	ax, 4
    movzx	eax, ax
    add		eax, 2
    sal		eax, 14
    or		eax, 1
    mov		[rootserver_id], eax
    
    call 	main
    

    L4_KDB_Enter goodbye_string

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; This is a main L4 userspace system call
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    public L4_Ipc as 'L4_Ipc'
L4_Ipc:
;
; 0030  L4_ThreadId_t *	from
; 002c  L4_Word_t 	Timeouts,
; 0028  L4_ThreadId_t 	FromSpecifier,
; 0024	L4_ThreadId_t 	to,
; 0020	Function return address	
; 001c	eax		Temp = esp
; 0018	ecx
; 0014	edx
; 0010	temp
; 000c	ebp
; 0008	esi
; 0004	edi	<- ebp points here

    pushad
    mov	  ebp, esp
    ; Set destination thread
    mov	  eax, [ ebp + 0x24 ]
    ; Set from specifier
    mov	  edx, [ ebp + 0x28 ]
    ; Set timeouts
    mov	  ecx, [ ebp + 0x2c ]
    ; Set UTCB
    mov	  edi, [ gs:0 ]
    ; Set message register 0
    mov   esi, [ edi ]
    ; Do L4 IPC syscall
    mov	  ebp, [kip]
    mov	  ebp, [ebp + 0xe0]
    add	  ebp, [kip]
    push  leave_ipc
    push  ebp
;    L4_KDB_Enter enter_msg
    ret
    
leave_ipc:
;    L4_KDB_Enter leave_msg
    ; Is message source is a nilthread?
    or	  eax, eax
    je	  skip_1
    ; Store MR1
    mov	  [edi + 4], ebx
    ; Store MR2
    mov	  [edi + 8], ebp
    skip_1:
    ; Restore EBP
    mov   ebp, esp
    ; Store MR0 on stack at eax position
    mov	  [ ebp + 0x1c ], esi
    ; Set FROM specifier
    mov	  ebx, [ ebp + 0x30 ]
    ; Check that FROM is not a NULL pointer
    or	  ebx, ebx
    je	  skip_2
    mov	  [ ebx ], eax
    skip_2:
    popad
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; UTCB area is an area where message registers stored 
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
public GetUTCB
GetUTCB:
    mov eax, [gs:0]
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; CONSTANT DATA AREA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.rodata' writable
hello_string:	db   'fasm is ready for Xameleon', 0x0d, 0x0a, 0
goodbye_string:	db   'See ya soon!', 0x0d, 0x0a, 0
enter_msg	db   'Before call', 0x0d, 0x0a, 0
leave_msg	db   'After call', 0x0d, 0x0a, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Static variables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' writeable
kip		dd		0
env_size	dd		0
rootserver_id	dd		0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Start of BSS area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.bss' writeable align 4
_BSS_start	dd		?

I_END:
