#define L4_ThreadId_t	unsigned int
#define L4_Word_t	unsigned int

//////////////////////////////////////////////////////////////////////////////
// Function prototypes
//////////////////////////////////////////////////////////////////////////////
extern L4_Word_t L4_Ipc (	
    L4_ThreadId_t 		to,
    L4_ThreadId_t 		FromSpecifier,
    L4_Word_t 			Timeouts,
    L4_ThreadId_t 	*	from);

extern L4_Word_t * GetUTCB();

//////////////////////////////////////////////////////////////////////////////
// External variables definition
//////////////////////////////////////////////////////////////////////////////
extern 	L4_ThreadId_t	rootserver_id;

//////////////////////////////////////////////////////////////////////////////
// Static variables definition
//////////////////////////////////////////////////////////////////////////////
static L4_ThreadId_t	filesystem_id = 0;


//////////////////////////////////////////////////////////////////////////////
// This function destroys its process by sending destroy command to Supervisor
//////////////////////////////////////////////////////////////////////////////
int sys_exit(int status)
{
    L4_ThreadId_t fake_from;
    L4_Word_t * MR = GetUTCB();
    MR[0] = 0x00040001;	// Message register 0 conveys information about message
    MR[1] = status;	// Process exit status
    MR[2] = 0x00040001;	// Message register 0 conveys information about message
    return L4_Ipc( rootserver_id, rootserver_id, 3, &fake_from );
}

/* Get handle of filesystem service */
L4_ThreadId_t	GetFilesystemHandle(void)
{
    static const char * szFilesystemID = "fs";
    L4_Word_t		tag;
    L4_ThreadId_t 	fake_from;
    L4_Word_t 	* 	MR = GetUTCB();
    
    do {
        MR[0] = 0x000c0080;		// 
        MR[1] = 0x00000c00;		// 
        MR[2] = (L4_Word_t) "fs";	// 
        tag = L4_Ipc( rootserver_id, rootserver_id, 3, &fake_from );
        if( tag & 0x00008000 ) break;	// IPC error
        if( MR[0] != 0x000c0002 ) break;
        if( MR[1] != 0x00000000 ) break;
        filesystem_id = MR[2];
    } while( 0 );
    
    return MR[1] ? MR[1] : MR[2];
}

int demo_of_write_syscall()
{
    L4_Word_t		tag;
    L4_ThreadId_t 	fake_from;
    L4_Word_t 	* 	MR = GetUTCB();
    
    do {
    
	MR[0] = 0x004c0081;				// 
	MR[1] = 0x00000001;				// stdout
	MR[2] = 0x00004400;				// 
	MR[3] = (L4_Word_t) "Hello WORLD!!!\r\n";	// 
	tag = L4_Ipc( filesystem_id, filesystem_id, 0x36623662, &fake_from );
        if( tag & 0x00008000 ) break;	// IPC error
        if( MR[0] != 0x000c0001 ) break;
        
    } while ( 0 );
    
    return MR[1];
}

/* just a C main function */
int main(void)
{
    GetFilesystemHandle();
    demo_of_write_syscall();
    sys_exit(13);
}
