#ifndef _IOPORTS_H
#define _IOPORTS_H

#include <l4/types.h>

inline void outb (int a, L4_Word8_t v) 
{ 
    __asm__ __volatile__ ("outb %1, %%dx"   : : "dN" (a), "a" (v)); 
}

inline L4_Word8_t inb  (int a)        
{ 
    L4_Word8_t	v;
    __asm__ __volatile__ ("inb %%dx, %0" :"=al"(v) :"dN"(a));
    return v;
}

inline void outw (int a, L4_Word16_t v) 
{ 
    __asm__ __volatile__ ("outw %1, %%dx"   : : "dN" (a), "a" (v)); 
}

inline L4_Word16_t inw  (int a)        
{ 
    L4_Word16_t	v;
    __asm__ __volatile__ ("inw %%dx, %0" :"=a"(v) :"dN"(a));
    return v;
}

inline void outl (int a, L4_Word32_t v) 
{ 
    __asm__ __volatile__ ("outl %1, %%dx"   : : "dN" (a), "a" (v)); 
}

inline L4_Word32_t inl  (int a)        
{ 
    L4_Word32_t	v;
    __asm__ __volatile__ ("inl %%dx, %0" :"=a"(v) :"dN"(a));
    return v;
}


#endif

