#ifndef _PTHREAD_H_
#define _PTHREAD_H_

#include <sys/cdefs.h>


typedef struct XAM_ThreadId
{
    int			raw;
} XAM_ThreadId_t;

typedef XAM_ThreadId_t	pthread_t;

typedef struct	pthread_attr_t
{
	char	*	thread_name;
} pthread_attr_t;

typedef struct {
	XAM_ThreadId_t	owner;
} pthread_mutex_t;

typedef void  pthread_mutexattr_t;

__BEGIN_DECLS

int  pthread_create(
	pthread_t  *  thread, 
	pthread_attr_t * attr, 
	void * (*start_routine)(void *), 
	void * arg);

int pthread_exit(void * value_ptr);

int pthread_mutex_init (
	pthread_mutex_t *MUTEX, 
	const pthread_mutexattr_t *MUTEXATTR);
	
int pthread_mutex_lock (pthread_mutex_t *mutex);

int pthread_mutex_unlock (pthread_mutex_t *MUTEX);

int pthread_mutex_destroy (pthread_mutex_t *MUTEX);

__END_DECLS

#endif 
