#ifndef _STDDEF_H_
#define _STDDEF_H_
/*
[CX]  The functionality described on this reference page is aligned with the ISO C standard. Any conflict between the requirements described here and the ISO C standard is unintentional. This volume of IEEE Std 1003.1-2001 defers to the ISO C standard. 
The <stddef.h> header shall define the following macros:

The implementation shall support one or more programming environments in which the widths of ptrdiff_t, size_t, and wchar_t are no greater than the width of type long. The names of these programming environments can be obtained using the confstr() function or the getconf utility.
*/

#ifndef NULL
#define NULL	0
#endif

typedef signed int		ptrdiff_t;	// Signed integer type of the result of subtracting two pointers. 
//typedef unsigned short	wchar_t;	// Integer type whose range of values can represent distinct wide-character codes for all members of the largest character set specified among the locales supported by the compilation environment: the null character has the code value 0 and each member of the portable character set has a code value equal to its value when used as the lone character in an integer character constant. 
typedef unsigned int	size_t;		// Unsigned integer type of the result of the sizeof operator. 
//typedef int		ssize_t;	// Signed integer type of the result of the sizeof operator. 

typedef long int		intmax_t;
typedef unsigned long int	uintmax_t;

#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *) NULL)->MEMBER)

#endif
