#ifndef _STDIO_H_
#define _STDIO_H_

#include <sys/cdefs.h>
#include <stdarg.h>

#ifndef NULL
#define NULL	0
#endif

#define BUFSIZ		4096

#define FILENAME_MAX	4096
#define L_tmpnam   16  // The size of tmpnam buffer

typedef void * FILE;

extern FILE * stdin;
extern FILE * stdout;
extern FILE * stderr;

#define		EOF		( (int) -1 )



#define _IOFBF          0x0001
#define _IOLBF          0x0002
#define _IONBF          0x0004


	__BEGIN_DECLS

//	int setvbuf( FILE * strean, char * buffer, int mode, size_t size);
	int setvbuf( FILE * strean, char * buffer, int mode, int size);

	int dprintf( int fd, const char *fmt, ... );
	int vsnprintf(char *str, int size, const char *fmt, va_list ap);
	int vsscanf(const char *str, const char *format, va_list ap);
	
	int snprintf(char *str, int size, const char *fmt, ... );
	int sprintf(char *str, const char *fmt, ... );
	int sscanf(const char *str, const char *format, ...);

	int _gets( int maxsize, char * str );
	int _printf( const char * format, ... );

	int printf( const char * format, ... );
	int vprintf( const char * format, va_list ap );
	int	putchar( int c );
	int scanf(const char *format, ...);

	FILE*	fdopen( int fd, const char * mode );
	FILE*	fopen(const char *path, const char *mode );
	int 	fclose( FILE * stream );
//	size_t  fread(void  *ptr,  size_t size, size_t count, FILE *stream);
//	size_t	fwrite(const void *ptr, size_t size, size_t count, FILE *stream);
	int		fread(void  *ptr,  int size, int count, FILE *stream);
	int		fwrite(const void *ptr, int size, int count, FILE *stream);


	int		fprintf( FILE * stream, const char * format, ... );
	int		vfprintf( FILE * stream, const char * format, va_list ap );
	int		fscanf(FILE *stream, const char *format, ...);
	int 	fgetc( FILE * stream );
	int		fputc( int c, FILE * stream );

	char*	fgets( char *s, int size, FILE * stream );
	int		fputs( const char * s, FILE * stream );

	char*	gets( char *s );
	int		puts( const char * s );

	int 	ungetc( int c, FILE * stream );
	int 	feof( FILE * stream );
	int		fseek( FILE * stream, long offset, int whence );
	int		fileno( FILE * stream );
	int		ferror( FILE * stream );
	void	clearerr( FILE * stream );
	long 	ftell( FILE * stream );
	int		fflush( FILE * stream );
	int 	rename(const char *oldpath, const char *newpath);
	int	remove(const char *pathname);
	void 	perror(const char * str);
	
	__END_DECLS

#define	getc( f )		fgetc( f )
#define	putc( c, f )		fputc( c, f )

#define getchar()		fgetc( stdin )
#define rewind( stream )	fseek( stream, 0, SEEK_SET )

#endif
