#ifndef _DEVICE_H_
#define _DEVICE_H_

#include <l4/types.h>

typedef enum
{
	category_RawDeviceService,
	category_StreamDeviceService,
	category_BlockDeviceService,
	category_ProtocolService,
	category_NetworkDeviceService,
} typeDriverCategory;

typedef enum
{
	drivermodel_Module,	// This means that service has been loaded by initial bootoader
	drivermodel_Process,	// System process would be a service
	drivermodel_Thread	// Some thread of another process would be a service
} typeDriverModel;

typedef struct 
{
	unsigned int			Major;				// Major device number
	unsigned int			Minor;				// Minor device number
	unsigned int			MinorCount;			// Count of minor devices
	typeDriverCategory		Category;			// Describes driver type: device or protocol
	typeDriverModel			Model;				// Kernel module or standalone process
	unsigned char			DeviceName[16];		// Device name (not null terminated)
} PublicDeviceRecord_t;

extern bool EnumerateDevice(
	int							nRecordNumber,
	PublicDeviceRecord_t	*	pRecord);
	
#endif
