#ifndef _SYS_RESOURCE_H_
#define _SYS_RESOURCE_H_

#include <sys/cdefs.h>
#include <sys/types.h>
#include <sys/time.h>

#define PRIO_PROCESS	0	// Identifies the who argument as a process ID. 
#define PRIO_PGRP		1	// Identifies the who argument as a process group ID. 
#define PRIO_USER		2	// Identifies the who argument as a user ID. 

typedef int rlim_t;

#define	RLIM_INFINITY	~0	// A value of rlim_t indicating no limit. 
#define	RLIM_SAVED_MAX	100	// A value of type rlim_t indicating an unrepresentable saved hard limit. 
#define	RLIM_SAVED_CUR	50	// A value of type rlim_t indicating an unrepresentable saved soft limit. 

struct rlimit 
{
	rlim_t	rlim_cur;	//  The current (soft) limit. 
	rlim_t	rlim_max;  //	The hard limit. 
};


struct rusage 
{
	struct timeval	ru_utime;	//  User time used. 
	struct timeval	ru_stime;	//  System time used. 
};

__BEGIN_DECLS

int  getpriority(int, id_t);
int  getrlimit(int, struct rlimit *);
int  getrusage(int, struct rusage *);
int  setpriority(int, id_t, int);
int  setrlimit(int, const struct rlimit *);

__END_DECLS


#endif
