#ifndef _SYS_TIME_H_
#define _SYS_TIME_H_

#include <sys/cdefs.h>

typedef struct timeval
{
	long			tv_sec;
	long			tv_usec;
} 
timeval_t;

typedef struct itimerval
{
	timeval_t		it_interval;
	timeval_t		it_value;
} 
itimerval_t;

#define		ITIMER_REAL			0
#define		ITIMER_VIRTUAL		1
#define		ITIMER_PROF			2
 
__BEGIN_DECLS

    int getitimer(int which, itimerval_t *value);
    int setitimer(int which, const itimerval_t *value, itimerval_t *ovalue);
    int gettimeofday(struct timeval * tp, void * tzp);
    
__END_DECLS

#endif
