#if ! defined XAM_PCI
#define XAM_PCI

#include "general.h"

typedef struct {
	uInt16		bIoSpace			: 1;
	uInt16		bMemorySpace		: 1;
	uInt16		bBusMaster			: 1;
	uInt16		bSpecialCycles		: 1;
	uInt16		bMemoryInvalieate	: 1;
	uInt16		bVgaPalleteSnoop	: 1;
	uInt16		bParityErrorResponse	: 1;
	uInt16		bReserved			: 1;
	uInt16		bSERREnable			: 1;
	uInt16		bFastB2BEnable		: 1;
	uInt16		bInterruptDisable	: 1;
	uInt16		nReserved			: 5;
} typePciCommandRegister;

typedef struct {
	uInt16		nReserved		: 3;
	uInt16		bInterruptStatus	: 1;
	uInt16		bCapabilitiesList	: 1;
	uInt16		b66MhzCapable		: 1;
	uInt16		bReserved		: 1;
	uInt16		bFastB2BCapable		: 1;
	uInt16		bMasterDataParityError	: 1;
	uInt16		nDevSelTiming		: 2;
	uInt16		bSignalledTargetAbort	: 1;
	uInt16		bReceivedTargetAbort	: 1;
	uInt16		bReceivedMasterAbort	: 1;
	uInt16		bSignalledSystemError	: 1;
	uInt16		bDetectedParityError	: 1;
} typePciStatusRegister;

typedef struct {
	uInt8		nResult 	: 4;
	uInt8		nReserved	: 2;
	uInt8		bStartBIST	: 1;
	uInt8		bCapableBIST	: 1;
} typePciBuiltinSelfTest;

typedef union {
	struct {
		uInt32		bSpaceIndicator	: 1;
		uInt32		nLocationType	: 2;
		uInt32		bPrefetchable	: 1;
		uInt32		nBaseAddress	: 12;
	} BaseAddressMemory;
	struct {
		uInt32		bSpaceIndicator	: 1;
		uInt32		bReserved	: 1;
		uInt32		nBaseAddress	: 14;
	} BaseAddressIO;
} typePciBaseAddress;

typedef struct {
	uInt16		DeviceID;			/*ro*/
	uInt16		VendorID;			/*ro*/
/**/	uInt16		Status;
/**/	uInt16		Command;
	uInt8		ClassCodeSpecific;		/*ro*/
	uInt8		ClassCodeSubclass;              /*ro*/
	uInt8		ClassCodeBase;                  /*ro*/
	uInt8		RevisionID;			/*ro*/
	uInt8		BIST;
	uInt8		HeaderType;			/*ro*/
	uInt8		LatencyTimer;
	uInt8		CacheLineSize;
	uInt32		BaseAddressRegisters[6];
	uInt32		CardbusCISPointer;
	uInt16		SubsystemID;
	uInt16		SubsystemVendorID;
	uInt32		ExpansionROMBaseAddress;
	uInt16		Reserved0;
	uInt8		Reserved1;
	uInt8		CapabilitesPointer;
	uInt32		Reserved2;
	uInt8           MaxLat;
	uInt8		MinGnt;
	uInt8		InterruptPin;
	uInt8		InterruptLine;
	uInt32		RomAddress;
} typePciCsHeader;


extern "C" int xam_request_device_configuration( 
	unsigned int				nDeviceID, 
	unsigned int				nDeviceFunction,
	typePciCsHeader			*	PciConfigurationData );

#endif
