#ifndef _TIME_H_
#define _TIME_H_

#include <sys/cdefs.h>
#include <sys/types.h>

struct tm {
	int     tm_sec;         /* seconds */
    int     tm_min;         /* minutes */
    int     tm_hour;        /* hours */
    int     tm_mday;        /* day of the month */
    int     tm_mon;         /* month */
    int     tm_year;        /* year */
    int     tm_wday;        /* day of the week */
    int     tm_yday;        /* day in the year */
    int     tm_isdst;       /* daylight saving time */
};

typedef long  clock_t;

__BEGIN_DECLS

time_t	time(time_t * t);
time_t  mktime(struct tm *tm);
time_t	mkgmtime(struct tm *);
struct tm *localtime(const time_t *timep);
char * ctime( const time_t * timep );
clock_t clock(void);

__END_DECLS

#endif
