#ifndef _UNICODE_H_
#define _UNICODE_H_

#ifdef WIN32 
	typedef wchar_t widechar_t;
#else
	typedef unsigned short widechar_t;
#endif

int MultiByteToWideChar(  
	unsigned int			CodePage,         	// code page  
	unsigned int			dwFlags,         	// character-type options  
	const char			* 	lpMultiByteStr, 	// string to map  
	int 					cbMultiByte,       	// number of bytes in string  
	widechar_t			*	lpWideCharStr,  	// wide-character buffer  
	int 					cchWideChar        	// size of buffer
	);

int WideCharToMultiByte(  
	unsigned int			CodePage,           // code page  
	unsigned int			dwFlags,            // performance and mapping flags  
	const widechar_t	*	lpWideCharStr,		// wide-character string  
	int 					cchWideChar,        // number of chars in string  
	char				*	lpMultiByteStr,     // buffer for new string  
	int 					cbMultiByte,          // size of buffer  
	const char			*	lpDefaultChar,     // default for unmappable chars  
	bool				*	lpUsedDefaultChar  // set when default char used
);	

#endif
