#ifndef _XAM_ERROR_CODES_
#define _XAM_ERROR_CODES_

#define S_OK			0

extern int errno;

const int XAM_EUNKNOWN             = -1;	/* Error code is not known */
const int XAM_ENOENT               = -2;	/* No such file or directory */
const int XAM_ESRCH                = -3;	/* No such process */
const int XAM_EINTR                = -4;	/* Interrupted system call */
const int XAM_EIO                  = -5;	/* I/O error */
const int XAM_ENXIO                = -6;	/* No such device or address */
const int XAM_E2BIG                = -7;	/* Arg list too long */
const int XAM_ENOEXEC              = -8;	/* Exec format error */
const int XAM_EBADF                = -9;	/* Bad file number */
const int XAM_ECHILD               = -10;	/* No child processes */
const int XAM_EAGAIN               = -11;	/* Try again */
const int XAM_ENOMEM               = -12;	/* Out of memory */
const int XAM_EACCES               = -13;	/* Permission denied */
const int XAM_EFAULT               = -14;	/* Bad address */
const int XAM_ENOTBLK              = -15;	/* Block device required */
const int XAM_EBUSY                = -16;	/* Device or resource busy */
const int XAM_EEXIST               = -17;	/* File exists */
const int XAM_EXDEV                = -18;	/* Cross-device link */
const int XAM_ENODEV               = -19;	/* No such device */
const int XAM_ENOTDIR              = -20;	/* Not a directory */
const int XAM_EISDIR               = -21;	/* Is a directory */
const int XAM_EINVAL               = -22;	/* Invalid argument */
const int XAM_ENFILE               = -23;	/* File table overflow */
const int XAM_EMFILE               = -24;	/* Too many open files */
const int XAM_ENOTTY               = -25;	/* Not a typewriter */
const int XAM_ETXTBSY              = -26;	/* Text file busy */
const int XAM_EFBIG                = -27;	/* File too large */
const int XAM_ENOSPC               = -28;	/* No space left on device */
const int XAM_ESPIPE               = -29;	/* Illegal seek */
const int XAM_EROFS                = -30;	/* Read-only file system */
const int XAM_EMLINK               = -31;	/* Too many links */
const int XAM_EPIPE                = -32;	/* Broken pipe */

const int XAM_EDOM                 = -33;	/* Math argument out of domain of func */
const int XAM_ERANGE               = -34;	/* Math result not representable */
const int XAM_EDEADLK              = -35;	/* Resource deadlock would occur */
const int XAM_ENAMETOOLONG         = -36;	/* File name too long */
const int XAM_ENOLCK               = -37;	/* No record locks available */
const int XAM_ENOSYS               = -38;	/* Function not implemented */
const int XAM_ENOTEMPTY            = -39;	/* Directory not empty */
const int XAM_ELOOP                = -40;	/* Too many symbolic links encountered */
const int XAM_EWOULDBLOCK          = -41;	/* Operation would block */
const int XAM_ENOMSG               = -42;	/* No message of desired type */
const int XAM_EIDRM                = -43;	/* Identifier removed */
const int XAM_EVERSION             = -44;	/* Protocol version error */
const int XAM_ENOSYNC              = -45;	/* Synchonization error */
const int XAM_EL3HLT               = -46;	/* Level 3 halted */
const int XAM_EL3RST               = -47;	/* Level 3 reset */
const int XAM_ELNRNG               = -48;	/* Link number out of range */
const int XAM_EUNATCH              = -49;	/* Protocol driver not attached */
const int XAM_ENOCSI               = -50;	/* No CSI structure available */
const int XAM_EL2HLT               = -51;	/* Level 2 halted */
const int XAM_EBADE                = -52;	/* Invalid exchange */
const int XAM_EBADR                = -53;	/* Invalid request descriptor */
const int XAM_EXFULL               = -54;	/* Exchange full */
const int XAM_ENOANO               = -55;	/* No anode */
const int XAM_EBADRQC              = -56;	/* Invalid request code 							!!!		*/
const int XAM_EBADSLT              = -57;	/* Invalid slot */
const int XAM_EPERM                = -58;	/* Operation not permitted */
const int XAM_EBFONT               = -59;	/* Bad font file format */
const int XAM_ENOSTR               = -60;	/* Device not a stream */
const int XAM_ENODATA              = -61;	/* No data available */
const int XAM_ETIME                = -62;	/* Timer expired */
const int XAM_ENOSR                = -63;	/* Out of streams resources */
const int XAM_ENONET               = -64;	/* Machine is not on the network */
const int XAM_ENOPKG               = -65;	/* Package not installed */
const int XAM_EREMOTE              = -66;	/* Object is remote */
const int XAM_ENOLINK              = -67;	/* Link has been severed */
const int XAM_EADV                 = -68;	/* Advertise error */
const int XAM_ESRMNT               = -69;	/* Srmount error */
const int XAM_ECOMM                = -70;	/* Communication error on send */
const int XAM_EPROTO               = -71;	/* Protocol error */
const int XAM_EMULTIHOP            = -72;	/* Multihop attempted */
const int XAM_EDOTDOT              = -73;	/* RFS specific error */
const int XAM_EBADMSG              = -74;	/* Not a data message */
const int XAM_EOVERFLOW            = -75;	/* Value too large for defined data type */
const int XAM_ENOTUNIQ             = -76;	/* Name not unique on network */
const int XAM_EBADFD               = -77;	/* File descriptor in bad state */
const int XAM_EREMCHG              = -78;	/* Remote address changed */
const int XAM_ELIBACC              = -79;	/* Can not access a needed shared library */
const int XAM_ELIBBAD              = -80;	/* Accessing a corrupted shared library */
const int XAM_ELIBSCN              = -81;	/* .lib section in a.out corrupted */
const int XAM_ELIBMAX              = -82;	/* Attempting to link in too many shared libraries */
const int XAM_ELIBEXEC             = -83;	/* Cannot exec a shared library directly */
const int XAM_EILSEQ               = -84;	/* Illegal byte sequence */
const int XAM_ERESTART             = -85;	/* Interrupted system call should be restarted */
const int XAM_ESTRPIPE             = -86;	/* Streams pipe error */
const int XAM_EUSERS               = -87;	/* Too many users */
const int XAM_ENOTSOCK             = -88;	/* Socket operation on non-socket */
const int XAM_EDESTADDRREQ         = -89;	/* Destination address required */
const int XAM_EMSGSIZE             = -90;	/* Message too long */
const int XAM_EPROTOTYPE           = -91;	/* Protocol wrong type for socket */
const int XAM_ENOPROTOOPT          = -92;	/* Protocol not available */
const int XAM_EPROTONOSUPPORT      = -93;	/* Protocol not supported */
const int XAM_ESOCKTNOSUPPORT      = -94;	/* Socket type not supported */
const int XAM_EOPNOTSUPP           = -95;	/* Operation not supported on transport endpoint */
const int XAM_EPFNOSUPPORT         = -96;	/* Protocol family not supported */
const int XAM_EAFNOSUPPORT         = -97;	/* Address family not supported by protocol */
const int XAM_EADDRINUSE           = -98;	/* Address already in use */
const int XAM_EADDRNOTAVAIL        = -99;	/* Cannot assign requested address */
const int XAM_ENETDOWN             = -100;	/* Network is down */
const int XAM_ENETUNREACH          = -101;	/* Network is unreachable */
const int XAM_ENETRESET            = -102;	/* Network dropped connection because of reset */
const int XAM_ECONNABORTED         = -103;	/* Software caused connection abort */
const int XAM_ECONNRESET           = -104;	/* Connection reset by peer */
const int XAM_ENOBUFS              = -105;	/* No buffer space available */
const int XAM_EISCONN              = -106;	/* Transport endpoint is already connected */
const int XAM_ENOTCONN             = -107;	/* Transport endpoint is not connected */
const int XAM_ESHUTDOWN            = -108;	/* Cannot send after transport endpoint shutdown */
const int XAM_ETOOMANYREFS         = -109;	/* Too many references: cannot splice */
const int XAM_ETIMEDOUT            = -110;	/* Connection timed out */
const int XAM_ECONNREFUSED         = -111;	/* Connection refused */
const int XAM_EHOSTDOWN            = -112;	/* Host is down */
const int XAM_EHOSTUNREACH         = -113;	/* No route to host */
const int XAM_EALREADY             = -114;	/* Operation already in progress */
const int XAM_EINPROGRESS          = -115;	/* Operation now in progress */
const int XAM_ESTALE               = -116;	/* Stale NFS file handle */
const int XAM_EUCLEAN              = -117;	/* Structure needs cleaning */
const int XAM_ENOTNAM              = -118;	/* Not a XENIX named type file */
const int XAM_ENAVAIL              = -119;	/* No XENIX semaphores available */
const int XAM_EISNAM               = -120;	/* Is a named type file */
const int XAM_EREMOTEIO            = -121;	/* Remote I/O error */
const int XAM_EDQUOT               = -122;	/* Quota exceeded */
const int XAM_ENOMEDIUM            = -123;	/* No medium found */
const int XAM_EMEDIUMTYPE          = -124;	/* Wrong medium type */

#endif

